﻿/* Copyright (c) 2012-2017 The ANTLR Project. All rights reserved.
 * Use of this file is governed by the BSD 3-clause license that
 * can be found in the LICENSE.txt file in the project root.
 */

#pragma once

#include "atn/ATNState.h"

namespace antlr4 {
namespace atn {

  class ANTLR4CPP_PUBLIC RuleStartState final : public ATNState {
  public:
    static bool is(const ATNState &atnState) { return atnState.getStateType() == ATNStateType::RULE_START; }

    static bool is(const ATNState *atnState) { return atnState != nullptr && is(*atnState); }

    RuleStopState *stopState = nullptr;
    bool isLeftRecursiveRule = false;

    RuleStartState() : ATNState(ATNStateType::RULE_START) {}
  };

} // namespace atn
} // namespace antlr4
